package com.gyee.wisdom.alarm.sharding.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gyee.wisdom.alarm.sharding.entity.Windturbine;
import com.gyee.wisdom.alarm.sharding.service.AlarmReportService;
import com.gyee.wisdom.alarm.sharding.service.AlarmSnapService;
import com.gyee.wisdom.alarm.sharding.util.SnowflakeGenerator;
import com.gyee.wisdom.alarm.sharding.util.StringUtil;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * @description:
 * @auther: Wanghs
 * @date: 2022-03-23
 */

@Slf4j
@RestController
@RequestMapping("/test")
@CrossOrigin
public class TestController {
    @Autowired
    private AlarmReportService reportService;

    @GetMapping(value = "/earlywarnscore")
    public String startCalcEarlyWarnScore() {
        String result = "";
        try {
            reportService.startCount();
            result = "诊断报告生成成功";


        } catch (Exception ex) {
            result = ex.getMessage().toString();
            log.error(ex.getStackTrace().toString());
        } finally {
            return result;
        }


    }

    @GetMapping(value = "/info")
    public Map<String, Windturbine> getTestInfo() {
        Windturbine w = new Windturbine();
        w.setId("123");
        w.setName("麻黄山1号风机");

        Map<String, Windturbine> mp = new HashMap<>();
        mp.put("1", w);
        mp.put("2", w);
        mp.put("3", w);
        System.out.println(JSON.toJSONString(mp));
        return mp;
    }

    @GetMapping("/id")
    @Operation(description = "根据字典类型获取字典集合")
    public JSONObject getSnowId() {

        JSONObject obj=new JSONObject();
        obj.put("id", SnowflakeGenerator.generateId());
        obj.put("name","wanghs");
        obj.put("age","32");
        return obj;
    }

    public static void main(String[] args) {

        List<Windturbine> lst = new ArrayList<>();

        Windturbine w1 = new Windturbine();
        Windturbine w2 = new Windturbine();
        Windturbine w3 = new Windturbine();
        Windturbine w4 = new Windturbine();
        Windturbine w5 = new Windturbine();

        w1.setId("1");
        w2.setId("2");
        w3.setId("3");
        w4.setId("4");
        w5.setId("1");

        w1.setName("风机1");
        w2.setName("风机2");
        w3.setName("风机3");
        w4.setName("风机4");
        w5.setName("风机5");
        lst.add(w2);
        lst.add(w1);
        lst.add(w3);
        lst.add(w4);
        lst.add(w5);

        lst.forEach(s -> System.out.println(s.getName()));
        System.out.println("==========");
        lst.sort((u1, u2) -> u1.getId().compareTo(u2.getId()));
        lst.forEach(s -> System.out.println(s.getName()));
        System.out.println("==========");
        lst.sort(Comparator.comparing(Windturbine::getId).thenComparing(Windturbine::getName));
        lst.forEach(s -> System.out.println(s.getName()));

        String difference = StringUtil.difference(w2.getName(), w1.getName());
        String s = StringUtil.prependIfMissing("456张三", "123", "456");

        System.out.println("123");

        boolean b = stringCompare();
        System.out.println(b);
    }

    public static boolean stringCompare(){
        String code="wanghs";
        char[] chr=code.toCharArray();
        for (int i = 0; i < chr.length; i++) {

            char key=chr[i];

            for (int j = i+1; j < chr.length; j++) {

                if(key==chr[j])
                    return false;
            }


        }
        return true;
    }
}
