package com.gyee.wisdom.alarm.sharding.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AccessLevel;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @description:
 * @auther: Wanghs
 * @date: 2022-06-17
 */

@Data
@TableName("STATIONINFO")
public class StationInfo implements Serializable {
    //风场id 如XXX_FDC
    @TableId("ID")
    private String id;

    //风场名称
    @TableField("NAME")
    private String name;

    //风机型号 双逗号隔开
    @TableField("MODELS")
    @Setter(AccessLevel.NONE)
    private String models;

    //风机小型号 双逗号隔开 小型号来源于windturbinetestingpointAI/DI表，主要是因为历史包袱，因点表配置不完整导致
    @TableField("POINT_MODELS")
    @Setter(AccessLevel.NONE)
    private String pointModels;

    @TableField("CATEGORY1")
    private String category1;

    @TableField("CATEGORY1")
    private String category2;

    @TableField("CATEGORY1")
    private String category3;

    @TableField(exist = false)
    private List<String> modelList;

    @TableField(exist = false)
    private List<String> pointModelList;


    public void setModels(String models) {
        this.models = models;
        String[] split = models.split(",,");
        this.modelList = Arrays.asList(split);
    }

    public void setPointModels(String pointModels) {
        this.pointModels = pointModels;
        String[] split = pointModels.split(",,");
        this.pointModelList = Arrays.asList(split);
    }


}
